diff --git a/doc/src/sgml/images/README b/doc/src/sgml/images/README
index 07c4580255..c451d4bca4 100644
--- a/doc/src/sgml/images/README
+++ b/doc/src/sgml/images/README
@@ -13,7 +13,8 @@ involve diffable source files.
 These tools are acceptable:
 
 - Graphviz (https://graphviz.org/)
-- Ditaa (http://ditaa.sourceforge.net/)
+- Ditaa (https://github.com/stathissideris/ditaa), version 0.11 or
+  higher. Previous versions does not support SVG.
 
 We use SVG as the format for integrating the image into the ultimate
 output formats of the documentation, that is, HTML, PDF, and others.
diff --git a/doc/src/sgml/images/gin.gv b/doc/src/sgml/images/gin.gv
index 097e91029a..d0442abf15 100644
--- a/doc/src/sgml/images/gin.gv
+++ b/doc/src/sgml/images/gin.gv
@@ -27,9 +27,12 @@ digraph "gin" {
                 e4 -> e8;
                 e4 -> e9;
 
-                e6 [fillcolor=green, label="posting list"];
-                e8 [fillcolor=green, label="posting list"];
-                e9 [fillcolor=green, label="posting list"];
+                e5 [fillcolor=green4, label="pointer to\nposting tree"];
+                e6 [fillcolor=green,  label="posting list"];
+                e7 [fillcolor=green4, label="pointer to\nposting tree"];
+                e8 [fillcolor=green,  label="posting list"];
+                e9 [fillcolor=green,  label="posting list"];
+
         }
 
         subgraph cluster02 {
@@ -45,8 +48,8 @@ digraph "gin" {
                 p1 -> p2;
                 p1 -> p3;
 
-                p2 [fillcolor=green, label="heap ptr"];
-                p3 [fillcolor=green, label="heap ptr"];
+                p2 [fillcolor=green, label="posting list"];
+                p3 [fillcolor=green, label="posting list"];
         }
 
         subgraph cluster03 {
@@ -56,7 +59,7 @@ digraph "gin" {
                         p4;
                 }
 
-                p4 [fillcolor=green, label="heap ptr"];
+                p4 [fillcolor=green, label="posting list"];
         }
 
         subgraph cluster04 {
@@ -72,14 +75,14 @@ digraph "gin" {
                 p5 -> p6;
                 p5 -> p7;
 
-                p6 [fillcolor=green, label="heap ptr"];
-                p7 [fillcolor=green, label="heap ptr"];
+                p6 [fillcolor=green, label="posting list"];
+                p7 [fillcolor=green, label="posting list"];
         }
 
         subgraph cluster05 {
                 label="pending list";
-                node [style=filled, fillcolor=red];
-                n1 -> n2 -> n3 -> n4;
+                node [fillcolor=red, label="pend. entries"];
+                n1 -> n2 -> n3 -> n4 -> n5;
         }
 
         m1 -> e1;
@@ -88,6 +91,8 @@ digraph "gin" {
         e7 -> p5;
         m1 -> n1;
 
-        e5 [style=filled, fillcolor=green4];
-        e7 [style=filled, fillcolor=green4];
+        // An explanation for readers
+        expl [shape=plaintext, fillcolor=green, label="          A <posting list> is a list of heap pointers (row IDs)              "];
+        p6 -> expl [style=invis];
+
 }
